//nTQ[
namespace MineScan {
  //gppbP[W
  using System;
  using Gtk;
  
  //n{^AButtonpăf[^ǉ
  public class MineButton : Button{
    //ǉϐQ
    private int   id;      //̔zԍ
    private bool  mineflg; //ntO,trueŒn
    private int   minecnt; //9}X̒n
    private Label minelbl; //{^ꂽՂɏo郉x
    private bool  status;  //ꂽtO,trueȂ牟Ă
    private const int height = 20, width = 20; //{^TCY

    //idQb^[
    public int Id{
      get{ return id; }
    }
    //ntOsetter,getter
    public bool Mineflg{
      set{ mineflg = value; }
      get{ return mineflg; }
    }
    //nsetter,getter
    public int Minecnt{
      set{ minecnt = value; }
      get{ return minecnt; }
    }
    //nxQb^[
    public Label Minelbl{
      get{ return minelbl; }
    }
    //Xe[^Xsetter,getter
    public bool Status{
      set{ status = value; }
      get{ return status; }
    }
    
    //RXgN^,ID
    public MineButton(int number){
      //IDݒ
      id = number;
      //TCYݒ
      HeightRequest = height;
      WidthRequest = width;
      //x쐬
      minelbl = new Label();
      //
      Init();
    }

    //{^
    public void Init(){
      //Ԃ͒nȂ,͒n0,ĂȂ,{^\,x\
      mineflg = false;
      minecnt = 0;
      status = false;
      Visible = true;
      Label = "";
      minelbl.Visible = false;
    }

    //{^NbN
    public void MineClick(){
      //tOĂ
      Status = true;
      //{^({^ƂłȂ)
      Visible = false;
      //xpeLXg쐬
      minelbl.Text =
        mineflg ? "B" : minecnt == 0 ? "-" : "" + minecnt;
      //x̃TCYwAȂłȂƂȂA_T
      //ARXgN^w肾ƂɃ_T߂
      minelbl.HeightRequest = height;
      minelbl.WidthRequest = width;
      //x\
      minelbl.Visible = true;
    }
  }

  public class Gundam : Random{
    //ӖȂ˂
    public int Destiny(int bound){
      return Next(bound);
    }
  }

  //Q[
  public class MineScan {
    //{^
    private static int hsize = 20, vsize = 16;
    private static int asize = vsize * hsize;
    //n
    private static int mines = 30;
    //K_V[h
    private static Gundam seed;
    //n{^
    private static MineButton [] button = new MineButton[asize];
    //eEBhE
    private static Gtk.Window win;
    //eEBhETCY
    private const int height = 600, width = 480; //{^TCY
    //Rg[tO
    private static bool ctrlflg;
    //cpl
    private static int restmine;
    private const int Control_L = 65507;
    
    //Main֐
    public static int Main (string[] args){
      //܂Ȃ
      Application.Init();

      //eEBhE
      win = new Gtk.Window ("MineScan");
      win.SetDefaultSize(height,width);
      win.Resize(height,width);
      win.Resizable = false;
      //eEBhEŁ~̃Cxgɒǉ
      win.DeleteEvent += new DeleteEventHandler (Window_Delete);

      //pl
      int number;
      HBox [] subbox = new HBox[vsize];
      HBox resetbox = new HBox();
      HBox toolbox = new HBox(false,1);
      VBox mainbox = new VBox();
      Button reset = new Button("RESET");
      Label hsizelbl = new Label("HSize:");
      Entry hsizebox = new Entry("" + hsize);
      Label vsizelbl = new Label("VSize:");
      Entry vsizebox = new Entry("" + vsize);
      Label mineslbl = new Label("Mines:");
      Entry minesbox = new Entry("" + mines);
      Button change = new Button("CHANGE");
      
      //Zbg{^ǉ
      reset.Clicked += new EventHandler(reset_click);
      resetbox.Add(reset);
      mainbox.PackStart(resetbox,false,false,0);

      //plɃ{^ǉ
      for(int i = 0; i < vsize; i++){
        subbox[i] = new HBox();
        for(int j = 0; j < hsize; j++){
          number = i * hsize + j;
          button[number] = new MineButton(number);
          button[number].Clicked += new EventHandler(btn_click);
          subbox[i].PackStart(button[number],false,false,0);
          subbox[i].PackStart(button[number].Minelbl,false,false,0);
        }
        mainbox.PackStart(subbox[i],false,false,0);
      }

      //c[o[쐬
      hsizebox.MaxLength = 2;
      hsizebox.WidthChars = 4;
      hsizebox.Editable = false;
      toolbox.PackStart(hsizelbl,false,false,0);
      toolbox.PackStart(hsizebox,false,false,0);
      vsizebox.MaxLength = 2;
      vsizebox.WidthChars = 4;
      vsizebox.Editable = false;
      toolbox.PackStart(vsizelbl,false,false,0);
      toolbox.PackStart(vsizebox,false,false,0);
      minesbox.MaxLength = 3;
      minesbox.WidthChars = 4;
      minesbox.Changed += new EventHandler(box_change);
      toolbox.PackStart(mineslbl,false,false,0);
      toolbox.PackStart(minesbox,false,false,0);
      change.Clicked += new EventHandler(change_click);
      toolbox.PackStart(change,false,false,0);
      mainbox.PackStart(toolbox,false,false,0);
      
      //eEBhEɒǉ
      win.Add(mainbox);
      win.KeyPressEvent += new KeyPressEventHandler(key_press);
      win.KeyReleaseEvent += new KeyReleaseEventHandler(key_release);

      //_}CY
      seed = new Gundam();

      //ZbgĂ
      Reset();

      //ʕ\AJn
      win.ShowAll ();
      Application.Run ();
      return 0;
    }

    //~{^_CxgAAvP[VI
    static void Window_Delete (object obj, DeleteEventArgs args){
      Application.Quit ();
      args.RetVal = true;
    }
    
    //Stop
    private static void Stop(){
      foreach(MineButton mb in button){
        mb.MineClick();
      }
    } 

    //Reset
    public static void Reset(){
      ButtonInit();
      GameInit();
    }

    //Q[
    private static void GameInit(){
      int cnt = 0;
      int pos, tpos;
      restmine = asize;
      ctrlflg = false;

      while(cnt < mines){
        //_ňʒu
        pos = seed.Destiny(asize);
        if(!button[pos].Mineflg){
          //_ʒuɃ{^uĎ̓}XɔeZ
          button[pos].Mineflg = true;
          for(tpos = pos - hsize; tpos <= pos + hsize; tpos += hsize){
            for(int i = -1; i <= 1 ; i++){
              if(0 <= tpos + i && tpos + i < asize && Math.Abs(pos % hsize - (tpos + i) % hsize) <= 1){
                button[tpos + i].Minecnt++;
              }
            }
          }
        }
        cnt++;
      }
    }

    //{^
    private static void ButtonInit(){
      foreach(MineButton mb in button){
        mb.Init();
      }
    }

    //Zbg{^
    private static void reset_click (object obj, EventArgs args){
      Reset();
    }
    
    //`FW{^
    private static void change_click (object obj, EventArgs args){
      Reset();
    }
    private static void box_change (object obj, EventArgs args){
      Entry e = (Entry)obj;
      try{
        if(e.Text.Length > 0) {
          mines = Int32.Parse(e.Text);
        } else {
          mines = 0;
        }
        if(mines < 10){
          mines = 10;
        } else if(mines > 80){
          mines = 80;
        }
      } catch(Exception ex){
        mines = 50;
      }
    }

    //n{^
    private static void btn_click (object obj, EventArgs args){
      MineButton mb = (MineButton)obj;
      //Rg[ĂȂΒʏ폈
      if(!ctrlflg && !mb.Status){
        //NbN
        mb.MineClick();
        restmine--;
        
        //0Ȃ̓}XJ
        if(mb.Minecnt == 0 && !mb.Mineflg){
          int tpos;
          int pos = mb.Id;
          for(tpos = pos - hsize; tpos <= pos + hsize; tpos += hsize){
            for(int i = -1; i <= 1 ; i++){
              if(0 <= tpos + i && tpos + i < asize &&
                 pos != tpos + i && Math.Abs(pos % hsize - (tpos + i) % hsize) <= 1 &&
                 !button[tpos + i].Status){
                btn_click(button[tpos + i], args);
              }
            }
          }
        }
        //n񂾂AEg
        if(mb.Mineflg){
          MessageDialog md = new MessageDialog (win,
                                                DialogFlags.Modal,
                                                MessageType.Error, 
                                                ButtonsType.Close, "Bomb! You lose!");
          md.Run();
          md.Destroy();
          Stop();
        }
        //cplnƓȂI
        if(restmine == mines){
          MessageDialog md = new MessageDialog (win,
                                                DialogFlags.Modal,
                                                MessageType.Error, 
                                                ButtonsType.Close, "AllOpen! You win!");
          md.Run();
          md.Destroy();
          Stop();
        }
      } else if (ctrlflg){
        //Rg[ĂtO
        string flaglbl;
        if(mb.Status){
          flaglbl = "";
        } else {
          flaglbl = "F";
        }
        mb.Label = flaglbl;
        mb.Status = !mb.Status;
      }
    }

    //L[Cxg
    private static void key_press (object obj, KeyPressEventArgs args){
      if((int)args.Event.Key == Control_L){
        ctrlflg = true;
      }
    }

    //L[Cxg
    private static void key_release (object obj, KeyReleaseEventArgs args){
      if((int)args.Event.Key == Control_L){
        ctrlflg = false;
      }
    }
  }
}
